{⨥  ࠭ Windows Bitmap  DOS  ࠩ VESA2}
{by MOTOCoder}

unit BMP;

interface

uses 
   crt,graph,vesa2;

type
  bmFileHeader = record{ 䠩}
    Typf : word;        {ᨣ }
    Size : longint;     { 䠩  }
    Res1 : word;        {१ࢨ஢}
    Res2 : word;        {१ࢨ஢}
    OfBm : longint;     {ᬥ饭 ࠦ   (1078)}
  end;
  
    bmFileHeader2 = record{ 䠩}       
    Size : longint;     { 䠩  }
    Res1 : word;        {१ࢨ஢}
    Res2 : word;        {१ࢨ஢}
    OfBm : longint;     {ᬥ饭 ࠦ   (1078)}
  end;
  
  bmInfoHeader = record   {ଠ樮 }
    Size : longint;       {    (40)}
    Widt : longint;       {ਭ ࠦ ( 窠)}
    Heig : longint;       { ࠦ ( 窠)}
    Plan : word;          {᫮ ᪮⥩ (1)}
    BitC : word;          {㡨 梥 (  ) (8)}
    Comp : longint;       {⨯ ᨨ (0 - )}
    SizI : longint;       {ࠧ ࠦ  }
    XppM : longint;       {ਧ⠫쭮 ࠧ襭}
           {(祪   - 筮 0)}
    YppM : longint;       {⨪쭮 ࠧ襭}
          {(祪   - 筮 0)}
    NCoL : longint;       {᫮ 梥⮢}
          {(᫨ ᨬ쭮 ⨬ - 0)}
    NCoI : longint;       {᫮ ᭮ 梥⮢}
  end;      
               
  bmHeader = record       {  䠩}
    f : bmFileHeader;     { 䠩}
    i : bmInfoHeader;     {ଠ樮 }
    p : array[0..255,0..3]of byte; {⠡ }
    end;
    
      bmHeader2 = record       {  䠩}
    f : bmFileHeader2;     { 䠩}
    i : bmInfoHeader;     {ଠ樮 }
    p : array[0..255,0..3]of byte; {⠡ }
  end;
 

procedure ReadBMPheader(filename:string;var header:bmheader);

procedure DrawBMP(filename:string;Cx,Cy:integer);

procedure SaveBMP(Cx,Cy,w,h:integer;Filename:string);


implementation

{$R-}

var
   pal:tdac;
   bmpal:array[0..255,0..3]of byte;

procedure ReadBMPheader(filename:string;var header:bmheader);
var
  bmpfile:file;
begin
   assign(bmpfile,filename);
   reset(bmpfile,1);
   blockread(bmpfile,header,sizeof(header));
   close(bmpfile);
end;

procedure Drawbmp(filename:string;Cx,Cy:integer);
var
  h  : bmHeader;
  i  : integer;
  bmpfile : file;
  x,y:integer;
  buf:integer;
begin
 readbmpheader(filename,h);
 assign(bmpfile,filename);
 for i:= 0 to 255 do
 begin
  setrgbcolor(i,h.p[i,2] shr 2,h.p[i,1]shr 2,h.p[i,0]shr 2);
 end;
 reset(bmpfile,1);
 seek(bmpfile,h.f.ofbm);
 for y:=h.i.heig downto 1  do
 begin
  for x:= 1 to h.i.widt do
  begin
   blockread(bmpfile,buf,1);
   putpixel(x+cx,y+cy,buf);
  end;
 end;
 close(bmpfile);
end;

procedure SaveBMP(Cx,Cy,w,h:integer;Filename:string);
var
hdr:bmheader2;
bmpfile:file;
ix,iy,i:integer;
buf:byte;
sbuf:string;
begin
 getpal(pal);
 
 hdr.f.size:=sizeof(hdr)+(h*w);
 hdr.f.res1:=0;
 hdr.f.res2:=0;
 hdr.f.ofbm:=1078;
 
 hdr.i.size:=40;
 hdr.i.widt:=w;
 hdr.i.heig:=h;
 hdr.i.plan:=1;
 hdr.i.bitc:=8;
 hdr.i.comp:=0;
 hdr.i.sizi:=h*w;
 hdr.i.xppm:=0;
 hdr.i.yppm:=0;
 hdr.i.ncol:=256;
 hdr.i.ncoi:=256;
 
 for i:=0 to 255 do
 begin
  hdr.p[i,0]:=pal[i].b shl 2;
  hdr.p[i,1]:=pal[i].g shl 2;
  hdr.p[i,2]:=pal[i].r shl 2;
  hdr.p[i,3]:=0;
 end;
 
 assign(bmpfile,filename);
 rewrite(bmpfile,1);
 buf:=byte('B');
 blockwrite(bmpfile,buf,1);
 buf:=byte('M');
 blockwrite(bmpfile,buf,1);
 
 blockwrite(bmpfile,hdr,sizeof(hdr));
 for iy:=h downto 1 do
 for ix:= 1 to w do
 begin
  buf:=getpixel(ix+cx,iy+cy);
  blockwrite(bmpfile,buf,1);
 end;
 
 
 close(bmpfile);
end;

end.
